/*  QMC: simplification tool (by using the Quine - McClusky process)
    Copyright (C) 2000  Thomas Pollak

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  

Auf Deutsch:

    QMC: Vereinfachungsprogramm fuer logische Terme nach Quine - McClusky
    Copyright (C) 2000  Thomas Pollak

    Dieses Programm ist freie Software. Sie koennen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder
    jeder spaeteren Version.

    Die Veroeffentlichung dieses Programms erfolgt in der
    Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
    GEWAEHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
    der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
    Details finden Sie in der GNU General Public License.

    Sie sollten eine Kopie der GNU General Public License zusammen
    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
    MA 02139, USA.
*/

//Headers
#include <cqmc>

//Debug - Switch
//#define DEBUG

#ifdef DEBUG
  #include <iostream>
#endif

using namespace std;

/**********************
 *                    *
 * create simple term *
 *                    *
 **********************/
void mintermerst(BOOL *var, BOOL *lh, unsigned char anz, unsigned short high, char *term)
{

  //local variables
  unsigned char j, check=0;

  unsigned short i, tindex=0;

  #ifdef DEBUG

    cerr << "\nMINT. Check";

    for(i=0;i<high*anz;i++)
    {
      if((i+anz)%anz==0 )
      {
        cerr << "\n    " << i/anz << '.';
      }

      cerr << '[' << lh[i].getid() << lh[i].value() << "] ";
    }

    cerr << "\n    finished!" << endl;

    cerr << "\nMINT. Hhe:" << high;

  #endif


  //rotate throw terms
  for(i=0;i<high;i++)
  {
    #ifdef DEBUG
      cerr << "\n\nnew expression" << endl;
    #endif

    for(j=0;j<anz;j++)
    {
      #ifdef DEBUG
        cerr << "\nID:" << lh[i*anz+j].getid() << " Val:" << lh[i*anz+j].value() << " Term:" << i << ", of " << high << "Index:" << j << ", von " << anz;
      #endif

      //check id
      if(lh[i*anz+j].getid()!='-')
      {
        //invert if LOW
        if(lh[i*anz+j].value()==0)
        {
          term[tindex]='/';
          tindex++;

          #ifdef DEBUG
            cerr << "Invertierd! ";
          #endif
        }

        #ifdef DEBUG
          cerr << " - [" << lh[i*anz+j].getid() << lh[i*anz+j].value() << "]  OK!";
        #endif

        //transfer content
        term[tindex]=var[j].getid();
        tindex++;
        check++;

        #ifdef DEBUG
          cerr << " - original: [" << var[j].getid() << ']';
        #endif

      }
    }

    //use or if term exsists
    if(check!=0)
    {
      term[tindex]='+';
      tindex++;
      check=0;
    }
  }

  #ifdef DEBUG
    cerr << "\n\nMINT. string created.";
  #endif

  if(high==0)
  {
    term[0]='0';
    term[1]='\0';
  }
  else if(tindex==0)
  {
    term[0]='1';
    term[1]='\0';
  }
  else
  {
    //terminate string
    term[tindex-1]='\0';
  }

  #ifdef DEBUG
    cerr << "\nMINT. string terminated.";
  #endif
}

